<template>
  <form class="py-4" @submit.prevent="emitSubmit">
    <div class="mb-2">
      <label
        for="book_title"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        title
      </label>
      <input
        id="book_title"
        v-model="item.title"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.title ? 'border-red-500' : 'border-gray-300',
        ]"
        type="text"
        placeholder=""
      />
      <div
        v-if="violations?.title"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.title }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="book_picture"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        picture
      </label>
      <input
        id="book_picture"
        v-model="item.picture"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.picture ? 'border-red-500' : 'border-gray-300',
        ]"
        type="text"
        placeholder=""
      />
      <div
        v-if="violations?.picture"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.picture }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="book_chapters"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        chapters
      </label>
      <FormRepeater
        :values="item.chapters"
        @update="(values: any[]) => (item.chapters = values)"
      />
      <div
        v-if="violations?.chapters"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.chapters }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="book_websites"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        websites
      </label>
      <FormRepeater
        :values="item.websites"
        @update="(values: any[]) => (item.websites = values)"
      />
      <div
        v-if="violations?.websites"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.websites }}
      </div>
    </div>

    <button
      type="submit"
      class="px-6 py-2 bg-green-500 text-white font-medium rounded shadow-md hover:bg-green-600"
    >
      Submit
    </button>
  </form>
</template>

<script lang="ts" setup>
import { toRef, ref, type Ref } from "vue";
import FormRepeater from "@/components/common/FormRepeater.vue";
import type { Book } from "@/types/book";
import type { SubmissionErrors } from "@/types/error";

const props = defineProps<{
  values?: Book;
  errors?: SubmissionErrors;
}>();

const emit = defineEmits<{
  (e: "submit", item: Book): void;
}>();

const violations = toRef(props, "errors");

let item: Ref<Book> = ref({});

if (props.values) {
  item.value = {
    ...props.values,
  };
}

function emitSubmit() {
  emit("submit", item.value);
}
</script>
